import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:test_sa/controllers/localization/localization.dart';
import 'package:test_sa/controllers/providers/api/gas_refill_provider.dart';
import 'package:test_sa/controllers/providers/api/user_provider.dart';
import 'package:test_sa/controllers/providers/settings/setting_provider.dart';
import 'package:test_sa/models/subtitle.dart';
import 'package:test_sa/views/app_style/colors.dart';
import 'package:test_sa/views/widgets/buttons/app_back_button.dart';
import 'package:test_sa/views/widgets/gas_refill/gas_refill_list.dart';
import 'package:test_sa/views/widgets/loaders/loading_manager.dart';

class TrackGasRefillPage extends StatefulWidget {
  static const String id = "/track-gas-refill";

  const TrackGasRefillPage({Key key}) : super(key: key);

  @override
  State<TrackGasRefillPage> createState() => _TrackGasRefillPageState();
}

class _TrackGasRefillPageState extends State<TrackGasRefillPage> with TickerProviderStateMixin {
  GasRefillProvider _gasRefillProvider;
  UserProvider _userProvider;
  SettingProvider _settingProvider;

  @override
  Widget build(BuildContext context) {
    if (_gasRefillProvider == null) {
      _gasRefillProvider = Provider.of<GasRefillProvider>(context);
      //_gasRefillProvider?.isLoading = false;
      _gasRefillProvider.reset();
    }
    _userProvider = Provider.of<UserProvider>(context);
    _settingProvider = Provider.of<SettingProvider>(context);
    Subtitle _subtitle = AppLocalization.of(context).subtitle;

    return Scaffold(
      body: SafeArea(
        child: LoadingManager(
          isLoading: _gasRefillProvider.isLoading,
          isFailedLoading: _gasRefillProvider.items == null,
          stateCode: _gasRefillProvider.stateCode,
          onRefresh: () async {
            _gasRefillProvider.reset();
            await _gasRefillProvider.getRequests(
              user: _userProvider.user,
              host: _settingProvider.host,
            );
          },
          child: Stack(
            children: [
              Column(
                children: [
                  Container(
                    color: AColors.white,
                    padding: const EdgeInsets.symmetric(horizontal: 0, vertical: 4),
                    child: Column(
                      children: [
                        Row(
                          children: [
                            ABackButton(),
                            Expanded(
                              child: Center(
                                child: Text(
                                  _subtitle.serviceRequests,
                                  style: Theme.of(context).textTheme.headline6.copyWith(color: AColors.grey3A, fontStyle: FontStyle.italic),
                                ),
                              ),
                            ),
                            const SizedBox(
                              width: 48,
                            )
                          ],
                        ),
                      ],
                    ),
                  ),
                  Expanded(
                    child: GasRefillList(
                      nextPage: _gasRefillProvider.nextPage,
                      onLazyLoad: () async {
                        await _gasRefillProvider.getRequests(
                          user: _userProvider.user,
                          host: _settingProvider.host,
                        );
                      },
                      items: _gasRefillProvider.items,
                    ),
                  ),
                ],
              ),
            ],
          ),
        ),
      ),
    );
  }
}
